/*DumpLine print various information about an emission line vector, 
 * used in debugging, print to std out, ioQQQ */
#include <string.h>
#include "cddefines.h"
#include "taulines.h"
#include "phycon.h"
#include "chlinelbl.h"
#include "texcline.h"
#include "dumpline.h"

void DumpLine(EmLine * t)
{
	char chLbl[11];

#	ifdef DEBUG_FUN
	fputs( "<+>DumpLine()\n", debug_fp );
#	endif

	/* routine to print contents of line arrays */
	strcpy( chLbl, chLineLbl(t) );

	fprintf( ioQQQ, 
		" Dump of %10.10s te=%e eden=%e CS=%8.2e Aul=%8.2e Texc=%e cool,heat=%e%e\n", 
	  chLbl, 
	  phycon.te, 
	  phycon.eden, 
	  t->cs, 
	  t->Aul, 
	  TexcLine(t), 
	  t->cool, 
	  t->heat );

	fprintf( ioQQQ, 
		"  Tin%e Tout%e EscP%e DesP%e Pump%e OTS%e PopL,U%e %e\n", 
	  t->TauIn, 
	  t->TauTot, 
	  t->Pesc, 
	  t->Pdest, 
	  t->pump, 
	  t->ots, 
	  t->PopLo, 
	  t->PopHi );

#	ifdef DEBUG_FUN
	fputs( " <->DumpLine()\n", debug_fp );
#	endif
	return;
}

