/*ipConSafe generate unique pointer to energy within continuum array
 * continuum energy in Rydbergs */
#include <string.h>
#include "cddefines.h"
#include "linelabl.h"
#include "ipoint.h"
#include "ipconsafe.h"

long ipConSafe(double energy, 
  char *chLabel)/* 4 char label for continuum, like those returned by chLineLbl */
{
	long int ipConSafe_v;

#	ifdef DEBUG_FUN
	fputs( "<+>ipConSafe()\n", debug_fp );
#	endif

	ipConSafe_v = ipoint(energy);

	/* write label in this cell if not anything there yet */
	if( strcmp(LineLabl.chContLabel[ipConSafe_v-1],"    ") == 0 )
	{
		strcpy( LineLabl.chContLabel[ipConSafe_v-1], chLabel );
	}


#	ifdef DEBUG_FUN
	fputs( " <->ipConSafe()\n", debug_fp );
#	endif
	return( ipConSafe_v );
}

