/* opac.h */

/* limit to number of opacity cells available in the opacity stack*/
#define	NOPSV	800000L

EXTERN struct t_opacCom {

	/*TauTotal is total optical depth at each energy, up to point, and through slab */
	float TauTotal[2][NCELL];

	/*tauabs, tausct, same for only absorption, scattering */
	float tauabs[2][NCELL];
	float tausct[2][NCELL];

	/*local opacity*/
	double opac[NCELL], 

	/* and the saved value of local opacity*/
	  opacsv[NCELL];

	/*save previous opacity */
	double OldOpacSave[NCELL];
	 
	/* scatop is total scattering opacity,*/
	double scatop[NCELL] ,

	/* albedo is local gas albedo*/
	  albedo[NCELL], 

	/* sctsav save local opacity at start of calculations*/
	  sctsav[NCELL];

	/* these static opacities are only evaluated 
	 * one time per zone*/
	double OpacStatic[NCELL];

	/* this flag is set true in zero, and set false with the
	 * no static opacities command.  When false always update
	 * all opacites */
	int lgOpacStatic;

	/* this flag is set true in opacz 
	 * when the OpacStatic array is zeroed, 
	 * and is false if the array has been left alone. 
	 * all later opacities must be reevaluated when this
	 * flag is true */
	int lgRedoStatic;

	/* factors that account for attenuation of light across this zone
	 * should be nearly unity */
	float tmn[NCELL];

	/* this is the stack used to hold opacities - entered one time when code
	 * is initialized, in routine opac0 */
	float OpacStack[NOPSV];


	/* flag set if negative opacities occured */
	int lgOpacNeg;

	/* flag saying whether (true) or not (false) scattering opacity
	 * is enabled */
	int lgScatON;

	/* IO unit to punch negative opacities */
	int lgNegOpacIO;

	/* density/temp factors needed for free-free opacity */
	double FreeFreeOpacity[NCELL];

	/* variable dealing with the option to generate and use an
	 * ancillary file containing a stored opacity set.  These
	 * are all initialized in zero1  */
	/*lgCompileOpac flag saying to compile opacity only */
	int lgCompileOpac;

		/*lgOpacExist flag saying that existing opacities used*/
	int lgOpacExist;

	/* set FALSE if no file opacity command entered, option to
	 * ignore opacity file */
	int lgUseFileOpac ;

	}	opac;

