/*plinin produce the 'punch lines intensity' output */
#include "cddefines.h"
#include "linesave.h"
#include "cddrive.h"
#include "zonecnt.h"
#include "readar.h"
#include "rdinit.h"
#include "punresult.h"
#include "plinin.h"

void plinin(FILE * io)
{
	char chCard[81];
	int lgEOF;
	long int i;

#	ifdef DEBUG_FUN
	fputs( "<+>plinin()\n", debug_fp );
#	endif

	/* used to punch out all the emission line intensities
	 * first initialize the line image reader */

	rdinit();

	fprintf( io, "**********************************************************************************************************************************\n" );
	
	lgEOF = FALSE;
	while( !lgEOF )
	{
		readar(chCard,&lgEOF);
		if( !lgEOF )
		{
				fprintf( io, "%s\n", chCard );
		}
	}

	/* first print any cautions or warnings */
	cdWarnings( io);
	cdCautions( io);
	fprintf( io, "zone=%5ld\n", ZoneCnt.nzone );
	fprintf( io, "**********************************************************************************************************************************\n" );
	fprintf( io, "begin emission lines\n" );

	/* >>chng 96 july 3, only punch zero intensities */
	PunResult(io,"    ",0,0.,"Start");
	for( i=0; i < LineSave.nsum; i++ )
	{
		if( LineSv[i].sumlin > 0. )
		{
			PunResult(io,(char*)LineSv[i].chALab,LineSv[i].lin,
			  LineSv[i].sumlin,"Line ");
		}
	}

	PunResult(io,"    ",0,0.,"Flush");

	fprintf( io, "     \n" );
	fprintf( io, "**********************************************************************************************************************************\n" );


#	ifdef DEBUG_FUN
	fputs( " <->plinin()\n", debug_fp );
#	endif
	return;
}

